#include <FL/Fl_Widget.H>
//our callback function, cast second parameter to our
//object class and call method
template<typename T, void (T::*method)()>
inline void cb(Fl_Widget* src, void* obj) {
        (((T*)obj)->*method)();
}

//this version is for methods with fltk::Widget* parameter
template<typename T, void (T::*method)(Fl_Widget*)>
inline void cb(Fl_Widget* src, void* obj) {
        (((T*)obj)->*method)(src);
}

template <typename T>
struct obj_h {
        
        T* obj;
        
        obj_h(T* obj): obj(obj) {}
        
        template <void (T::*method)()>
        void connect(Fl_Widget& widget) {
                widget.callback(cb<T, method>, obj);
        }

        template <void (T::*method)(Fl_Widget*)>
        void connect(Fl_Widget& widget) {
                widget.callback(cb<T, method>, obj);
        }
};

template <typename T>
inline obj_h<T> obj(T& o) {
        return obj_h<T>(&o);
}

template <typename T>
inline obj_h<T> obj(T* o) {
        return obj_h<T>(o);
}

/* And now small example: */

/* struct SomeClass { */
/*  void someMethod(/\*optional: fltk::Widget* src*\/) { */
/*   ... */
/*  } */
/* } */

/* ... */

/* SomeClass someObj; */
/* fltk::Button button(...); */
/* obj(someObj).connect<&SomeClass::someMethod>(button); */
