#include "synth_gui.h"
#include "callback.h"

namespace stupid_fucking_hack {
  void cb(Synth_Button *);
  void toggle_cb(Synth_Toggle *);
}



Synth_Toggle::Synth_Toggle(int x, int y, unsigned width, unsigned height,
			   const char *title, char *p, int ini)
  : Fl_Light_Button(x, y, width, height, title) {
  parameter = p;
  *parameter = ini;
  init();
  set_value = 1;
}

void Synth_Toggle::init() {
  box(FL_PLASTIC_UP_BOX);
  selection_color(FL_RED);
  when(FL_WHEN_CHANGED);
  labeltype(FL_ENGRAVED_LABEL);
  callback((void(*)(Fl_Widget*))stupid_fucking_hack::toggle_cb);
}

Synth_Toggle::Synth_Toggle(int x, int y, unsigned width, unsigned height,
			   const char *title, char *p, char val, bool set)
  : Fl_Light_Button(x, y, width, height, title) {
  parameter = p;
  if (set) {
    setonly();
    *parameter = val;
  }
  type(FL_RADIO_BUTTON);
  set_value = val;
  init();
}

void stupid_fucking_hack::toggle_cb(Synth_Toggle *t) {
  *t->parameter=t->value()*t->set_value;
}
 
Synth_Button::Synth_Button(int x, int y, unsigned width, unsigned height,
			   const char *title, Toplevel *p,
			   enum synth_gui_actions index)
  : Fl_Button(x, y, width, height, title) {
  box(FL_PLASTIC_UP_BOX);
  labeltype(FL_ENGRAVED_LABEL);
  idx = index;
  parent = p;
  callback((void(*)(Fl_Widget*))stupid_fucking_hack::cb);
}

void Synth_Button::callback_dispatch() {
  parent->manipulate(idx);
}

void stupid_fucking_hack::cb(Synth_Button *b) {
  b->callback_dispatch();
}

Synth_Gui::Synth_Gui(const char *title)
  : Fl_Double_Window(100, 100, title) {
  // bind this to kill the whole app when closed
  box(FL_PLASTIC_UP_BOX);
  unsigned margin = 10;
  unsigned knob_width = 60;
  unsigned button_width = 100;
  unsigned button_height = 40;
  unsigned left_box = margin;
  unsigned left_base = left_box + margin;
  unsigned left_range = left_base + knob_width + margin;
  unsigned left_amp = left_range + knob_width + margin;
  unsigned left_button = left_amp + knob_width + margin;
  unsigned left_box_end = left_button + button_width  + margin + margin;
  unsigned middle_box = left_box_end + margin;
  unsigned middle_button = middle_box + margin;
  unsigned middle_box_end = middle_button + button_width + margin;
  unsigned right_box = middle_box_end + margin;
  unsigned right_base = right_box + margin + margin;
  unsigned right_range = right_base + knob_width + margin;
  unsigned right_amp = right_range + knob_width + margin;
  unsigned right_button = right_amp + knob_width + margin;
  unsigned right_box_end = right_button + button_width + margin;
  unsigned width = right_box_end + margin;

  unsigned top_box = margin;
  unsigned top_widget = top_box + margin;
  unsigned top_sub_widget = top_widget + button_height;
  unsigned top_box_end = top_sub_widget + button_height + margin + margin;
  unsigned bottom_box = top_box_end + margin*2;
  unsigned bottom_widget = bottom_box + margin + margin;
  unsigned bottom_sub_widget = bottom_widget + button_height;
  unsigned bottom_box_end = bottom_sub_widget + button_height + margin;
  unsigned height = bottom_box_end + margin*2;

  resize(x(), y(), width, height);

  Fl_Box * up_left = new Fl_Box(left_box, top_box, left_box_end - left_box,
				top_box_end - top_box); 
  Fl_Box * master = new Fl_Box(middle_box, top_box, middle_box_end - middle_box,
			        bottom_box_end- top_box);
  Fl_Box * up_right = new Fl_Box(right_box, top_box, right_box_end - right_box,
				 top_box_end - top_box);
  Fl_Box * down_left = new Fl_Box(left_box, bottom_box, left_box_end - left_box,
				  bottom_box_end - bottom_box); 
  Fl_Box * down_right = new Fl_Box(right_box, bottom_box,
				   right_box_end - right_box,
				   bottom_box_end - bottom_box); 
  new Synth_Button(left_button, top_widget, button_width, button_height,
		   "&left wave", this, show_left_waveform);
  new Synth_Button(right_button, top_widget, button_width, button_height,
		   "&right wave", this, show_right_waveform);
  new Synth_Button(left_button, bottom_widget, button_width, button_height,
		  "&Left control", this, show_left_control);
  new Synth_Button(right_button, bottom_widget, button_width, button_height,
		  "&Right control", this, show_right_control);
  new Synth_Toggle(left_button, top_sub_widget, button_width, button_height,
		   "&mute", &synth_data->left.mute, 0);
  new Synth_Toggle(right_button, top_sub_widget, button_width, button_height,
		   "&Mute", &synth_data->right.mute, 0);
  new Synth_Toggle(left_button, bottom_sub_widget, button_width, button_height,
		   "&control", &synth_data->left.control, 0);
  new Synth_Toggle(right_button, bottom_sub_widget, button_width, button_height,
		   "&Control", &synth_data->right.control, 0);
  new Pot(left_base, top_widget, knob_width, "base", &synth_data->left.center,
	  0.0f, 20000.0f, 4.0f, 0.50f);
  new Pot(left_range, top_widget, knob_width, "range", &synth_data->left.range,
	  0.0f, 20000.0f, 4.0f, 0.50f);
  new Pot(left_amp, top_widget, knob_width, "amp", &synth_data->left.amp,
	  0.0f, 10.0f, 4.0f, 0.50f);
  new Pot(right_base, top_widget, knob_width, "base", &synth_data->right.center,
	  0.0f, 20000.0f, 4.0f, 0.500f);
  new Pot(right_range, top_widget, knob_width, "range",
	  &synth_data->right.range, 0.0f, 20000.0f, 4.0f, 0.50f);
  new Pot(right_amp, top_widget, knob_width, "amp", &synth_data->right.amp,
	  0.0f, 10.0f, 4.0f, 0.50f);
  new Pot(left_base, bottom_widget, knob_width, "base",
	  &synth_data->left.speed_center, 0.0f, 20000.0f, 15.0f, 0.050f);
  new Pot(left_range, bottom_widget, knob_width, "range",
	  &synth_data->left.speed_range, 0.0f, 20000.0f, 8.0f, 0.050f);
  new Pot(left_amp, bottom_widget, knob_width, "control",
	  &synth_data->left.control_range, 0.0f, 20000.0f, 4.0f, 0.50f);
  new Pot(right_base, bottom_widget, knob_width, "base",
	  &synth_data->right.speed_center, 0.0f, 20000.0f, 15.0f, 0.050f);
  new Pot(right_range, bottom_widget, knob_width, "range",
	  &synth_data->right.speed_range, 0.0f, 20000.0f, 8.0f, 0.050f);
  new Pot(right_amp, bottom_widget, knob_width, "control",
	  &synth_data->right.control_range, 0.0f, 20000.0f, 4.0f, 0.50f);
  new Pot(middle_button+10, top_widget, 80, "master gain",
	  &synth_data->master, 0.0f, 10.0f, 4.0f, 0.50f);
  {
    Fl_Group *g = new Fl_Group(middle_button, bottom_widget-40, button_width,
			       button_height/2, "interpolation");
    g->align(FL_ALIGN_BOTTOM|FL_ALIGN_LEFT);
    g->labeltype(FL_EMBOSSED_LABEL);
    new Synth_Toggle(middle_button, bottom_widget-40, button_width/3,
		     button_height/2, "&0", &synth_data->interp,
		     0, false);
    new Synth_Toggle(middle_button+button_width/3, bottom_widget-40,
		     button_width/3, button_height/2, "&2", &synth_data->interp,
		     2, false);
    new Synth_Toggle(middle_button+(button_width*2)/3, bottom_widget-40,
		     button_width/3, button_height/2, "&4", &synth_data->interp,
		     4, true);
    g->end();
  }
  new Synth_Toggle(middle_button, bottom_widget, button_width, button_height,
		   "mute &all", &synth_data->mute, 0);
  new Synth_Toggle(middle_button, bottom_sub_widget,
		   button_width, button_height,
		   "&freeze", &synth_data->freeze, 0);
  
  up_left->box(FL_PLASTIC_DOWN_BOX);
  up_left->color(FL_FOREGROUND_COLOR);
  up_right->box(FL_PLASTIC_DOWN_BOX);
  up_right->color(FL_FOREGROUND_COLOR);
  master->box(FL_PLASTIC_DOWN_BOX);
  master->color(FL_FOREGROUND_COLOR);
  down_left->box(FL_PLASTIC_DOWN_BOX);
  down_left->color(FL_FOREGROUND_COLOR);
  down_right->box(FL_PLASTIC_DOWN_BOX);
  down_right->color(FL_FOREGROUND_COLOR);

  left_waveform = new Waveform_Editor(1000, 400, 60, 0, "Left Waveform");
  right_waveform = new Waveform_Editor(1000, 400, 60, 1, "Right Waveform");
  left_control = new Waveform_Editor(1000, 400, 120, 2, "Left Control");
  right_control = new Waveform_Editor(1000, 400, 120, 3, "Right Control");

  editors[0] = left_waveform;
  Waveforms[0].data = left_waveform->display->audio_data;
  Waveforms[0].size =  left_waveform->display->data_count;
  synth_data->left.waveform = 0;

  editors[1] = right_waveform;
  Waveforms[1].data = right_waveform->display->audio_data;
  Waveforms[1].size = right_waveform->display->data_count;
  synth_data->right.waveform = 1;

  editors[2] = left_control;
  Waveforms[2].data = left_control->display->audio_data;
  Waveforms[2].size = left_control->display->data_count;
  synth_data->left.control = 2;

  editors[3] = right_control;
  Waveforms[3].data = right_control->display->audio_data;
  Waveforms[3].size = right_control->display->data_count;
  synth_data->right.control = 3;

  show();
}

void Synth_Gui::manipulate(enum synth_gui_actions idx) {
  switch (idx) {
  case show_left_waveform:
      left_waveform->show();
    break;
  case show_right_waveform:
      right_waveform->show();
    break;
  case show_left_control:
      left_control->show();
    break;
  case show_right_control:
      right_control->show();
    break;
  default:
    fprintf(stderr, "unsupported index: %d\n", idx);
  }
}

void Toplevel::manipulate(enum synth_gui_actions idx) {
  fprintf(stderr, "this should have remained abstract\n");
}
