#ifndef synth_gui_h
#define synth_gui_h

#include "globals.h"
#include "waveform_editor.h"
#include "pot.h"
#include <FL/Fl_Double_Window.H>
#include "stdio.h"

enum synth_gui_actions {
  show_left_waveform=0,
  show_right_waveform=1,
  show_left_control=2,
  show_right_control=3
};

class Synth_Toggle : public Fl_Light_Button {
public:
  Synth_Toggle(int x, int y, unsigned width, unsigned height,
	       const char *title, char *p, char val, bool set);
  Synth_Toggle(int x, int y, unsigned width, unsigned height,
	       const char *title, char *p, int init);
  char *parameter;
  char set_value;
 private:
  void init();
};

class Synth_Input {
 public:
  enum synth_gui_actions idx;
};

class Toplevel {
 public:
  virtual void manipulate(enum synth_gui_actions act);
};

class Synth_Button : public Fl_Button, public Synth_Input {
 public:
  Synth_Button(int x, int y, unsigned width, unsigned height,
	       const char *title, Toplevel *p,
	       enum synth_gui_actions idx);
  void callback_dispatch();
  Toplevel *parent;
};

class Synth_Gui : public Fl_Double_Window, public Toplevel {
 public:
  void manipulate(enum synth_gui_actions idx);
  Synth_Gui(const char *title);
  Waveform_Editor *left_waveform;
  Waveform_Editor *right_waveform;
  Waveform_Editor *left_control;
  Waveform_Editor *right_control;
 private:
};

#endif
