#include "waveform_button.h"

void round_cb(Waveform_Round_Button *);
void button_callback_gateway(Waveform_Button *);

Waveform_Round_Button::Waveform_Round_Button(int x, int y, int width,
					     int height, const char *label,
					     bool *val)
  :Fl_Light_Button(x, y, width, height, label) {
  v = val;
  box(FL_PLASTIC_UP_BOX);
  //down_box(FL_PLASTIC_DOWN_BOX);
  selection_color(FL_RED);
  labeltype(FL_ENGRAVED_LABEL);
  labelsize(10);
  align(FL_ALIGN_CLIP);
  when(FL_WHEN_CHANGED);
  callback((void(*)(Fl_Widget*))round_cb);
}

Waveform_Button::Waveform_Button(int x, int y, int width, int height,
				 const char *label, enum actions a, unsigned w)
  :Fl_Button(x, y, width, height, label) {
  box(FL_PLASTIC_UP_BOX);
  down_box(FL_PLASTIC_DOWN_BOX);
  labeltype(FL_ENGRAVED_LABEL);
  labelsize(10);
  align(FL_ALIGN_CLIP);
  waveform_editor = w;
  act = a;
  callback((void(*)(Fl_Widget*))button_callback_gateway);
}


void round_cb(Waveform_Round_Button *rb) {
  *rb->v = (bool) rb->value();
}

void button_callback_gateway(Waveform_Button * b) {
  b->callback_dispatch();
}

void Waveform_Button::callback_dispatch() {
  editors[waveform_editor]->manipulate(act);
}
