#ifndef waveform_display_h
#define waveform_display_h

#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl.H>

#include <stdlib.h>
#include <math.h>
#include "range_definition.h"

#define clip_range(X, MN, MX) (X < MN) ? MN : ((X > MX) ? MX : X)

enum actions {
  fill = 0,
  drunk = 1,
  rndm = 2,
  copy = 3,
  paste = 4,
  zero = 5,
  shrink = 6,
  grow = 7,
  smooth = 8,
  rough = 9,
  up = 10,
  down = 11
};

class Waveform_Display : public Fl_Group {
 public:
  Waveform_Display(int x, int y, int width, int height, int count, int *l,
		   int *r, unsigned ratio);
  bool scatter;
  int handle(int event);
  void manipulate(enum actions how);
  Range_Definition *active;
  float *audio_data;
  unsigned data_count;
 private:
  static unsigned paste_buffer_size;
  static unsigned paste_buffer_range;
  static unsigned paste_buffer_used;
  static int *paste_buffer;
  int x_to_point(int x);
  int setpoint(int which, int value);
  int *left;
  int *right;
  int middle;
  float point_size;
  int point_count;
  int point_start_x;
  int point_start_y;
  int point_end_y;
  int range;
  Fl_Box **points;
  int visual_data_ratio;
  float data_scale;
  float data_offset;
};

#endif
