#ifndef waveform_editor_h
#define waveform_editor_h

#include <FL/Fl_Double_Window.H>

#include "waveform_display.h"
#include "waveform_button.h"

enum waveform_edit_action {
  hde = 0
};

class Waveform_Editor : public Fl_Double_Window {
 public:
  Waveform_Editor(int width, int height, int points, unsigned id,
		  const char *name);
  void manipulate(enum actions how);
  Waveform_Display *display;
  void dispatch(enum waveform_edit_action act);
 private:
  Range_Definition *range;
  unsigned id;
};

extern Waveform_Editor **editors;

class Editor_Button : public Fl_Button {
public:
  Editor_Button(int x, int y, int width, int height, const char *name,
		enum waveform_edit_action a, Waveform_Editor *p);
  Waveform_Editor *parent;
  enum waveform_edit_action act;
};

#endif
